#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>

#include "eiwic.h"
#include "plugins.h"

#define GF_SUCCESS "try %s"
#define GF_FAILED "nothing has been found :|"

EP_SETNAME("google");

typedef struct google_request {
	MSG msg;
	char request[128];
	CONN *conn;
} REQ;

int google_found(char *retrieved, void *data)
{
	REQ *req = data;
	char *p;

	if ((p = strstr(((HTTP*)(req->conn->data))->buffer, "Location: ")) != NULL) {
		mlink->plug_sendf(
				"PRIVMSG %s :%s, "GF_SUCCESS"\r\n",
				req->msg.to, req->msg.nick, strtok(p + 10, "\r\n"));
	}
	else {
		mlink->plug_sendf(
				"PRIVMSG %s :%s, "GF_FAILED"\r\n",
				req->msg.to, req->msg.nick);
	}
	free(req);

	return 1;
}

int find(char *parameter, MSG *msg)
{
	REQ *r;
	char http[170], *p;
		
	if (parameter == NULL)
		return -1;

	r = malloc(sizeof(REQ));
	memcpy(&r->msg, msg, sizeof(MSG));
	strncpy(r->request, parameter, 127);
	p = r->request;
	while (*p++) if (*p == ' ') *p = '+';

	sprintf(http,"http://www.google.com/search?btnI=&q=%s", r->request);
	r->conn = mlink->conn_http_get(http, google_found, r);
	return 0;
}

int ep_main()
{
	mlink->plug_trigger_reg("!find", TRIG_PUBLIC, find);
	mlink->plug_trigger_reg("!google", TRIG_PUBLIC, find);

	return 1;
}

