#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>
#include <time.h>
#include <errno.h>

#include "eiwic.h"
#include "plugins.h"

#define HEISE_DATAFILE "heise.dat"
#define DELAY_MIN 15 /* how many minutes to wait between the updates */
#define NEWS_COUNT 3 /* how many news should be posted maximally */

EP_SETNAME("heise");

CHANNEL *post_chan;

void heise_retrieve(void *);


char *heise_html_cleanup(char *string)
{
	char *p=string, rp, length;

	while (*p)
	{
		if (*p == '&')
		{
			rp = '\0';
			
			if (strncmp(p+1, "uuml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "auml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "ouml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "quot;", length=5) == 0) rp = '\"';
			else if (strncmp(p+1, "Auml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "Ouml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "Uuml;", length=5) == 0) rp = '';
			else if (strncmp(p+1, "szlig;", length=6) == 0) rp = '';			

			if (rp)
			{			
				memmove(p, p+length, strlen(p+length)+1);
				*p = rp;
			}
		}

		++p;
	}

	return string;
}

int heise_reply(char *retrieved, void *data)
{	
	char *a=retrieved, *p, *url, *headline, buf[1024], found=0;
	int i, cur = 0;
	FILE *heise_dat;
	
	heise_dat = fopen(HEISE_DATAFILE, "a+");

	if (!heise_dat)
	{
		mlink->log(LOG_WARNING, "Couldn't open "HEISE_DATAFILE": %s", strerror(errno));
		return 0;
	}
	
#ifdef VV_DEBUG
	mlink->log(LOG_DEBUG, "%d bytes recieved, fd("HEISE_DATAFILE"):%d", strlen(retrieved), heise_dat);
#endif
	
	while ((p = strstr(a, "<BR>&nbsp;&nbsp;<A HREF=\"")) != NULL && cur < NEWS_COUNT)
	{
		fseek(heise_dat, 0, SEEK_SET);
		
		p += 25;
		url = p;
		if (!(headline = strstr(url, "\">")))
			break;
		*headline = 0;
		headline += 2;
		a = strstr(headline, "</A>");

		*a = 0;
		a += 1;
		
		while (fgets(buf, sizeof(buf) - 1, heise_dat) && found == 0) {			
			for (i = 0; buf[i] == url[i] || buf[i] == ':'; ++i)
				if (buf[i] == ':' || url[i] == ':') {
					found = 1;
					break;
				}
		}

		if (found)
		{
			/* fprintf(stderr, "found: %s\n", url); */
		}
		else
		{			
			/*	fprintf(stderr, "not found %s:%s\n", url, headline); */
			fprintf(heise_dat, "%s:%s\n", url, headline);			
			mlink->plug_sendf("PRIVMSG %s :%s: http://heise.de%s\r\n",
					((CHANNEL *)e_global->channels.head->data)->name,
					heise_html_cleanup(headline), url);
		}

		++cur;
	}
	
	fflush(heise_dat);
	fclose(heise_dat);

	mlink->plug_timer_reg(time(NULL) + 60*DELAY_MIN, heise_retrieve, NULL);

	return 1;
}

void heise_retrieve(void *data)
{	
	mlink->conn_http_get("http://www.heise.de/newsticker/", heise_reply, NULL);	
}

int heise_onoff(char *parameter, MSG *msg)
{
	mlink->plug_sendf("PRIVMSG %s :heise: %s\r\n", msg->to, parameter);
	
	return 1;
}

/* plugin main function, register !heise trigger */
int ep_main()
{
/*	mlink->plug_trigger_reg("!heise", TRIG_PUBLIC, heise_onoff); */
	mlink->plug_timer_reg(time(NULL)+10, heise_retrieve, NULL);
	
	return 1;
}
