#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>

#include "eiwic.h"
#include "plugins.h"

EP_SETNAME("modadmin");

/* from http://www.codeproject.com */
int wildcmp(char *wild, char *string) { 
	char *cp, *mp; 

	while ((*string) && (*wild != '*')) { 
		if ((*wild != *string) && (*wild != '?')) { 
			return 0; 
		} 
		wild++; 
		string++; 
	} 

	while (*string) { 
		if (*wild == '*') { 
		if (!*++wild) { 
		return 1; 
	} 
	mp = wild; 
	cp = string+1; 
	} else if ((*wild == *string) || (*wild == '?')) { 
		wild++; 
		string++; 
	} else { 
		wild = mp; 
		string = cp++; 
	} 
	} 

	while (*wild == '*') { 
	wild++; 
	} 
	return !*wild; 
}


int on_insmod(char *parameter, MSG *ircmsg)
{
	PLUGIN *p =	mlink->plug_load(parameter);
	if (p == NULL)
	{
		mlink->plug_sendf("PRIVMSG %s :insmod: could not find or load '%s'\r\n", ircmsg->to, parameter);
	}
	else
	{
		mlink->plug_sendf("PRIVMSG %s :insmod: added module \002%s\002 (path: %s)\r\n", ircmsg->to, p->name, p->filename);
	}

	return 1;
}

int on_rmmod(char *parameter, MSG *ircmsg)
{
	mlink->plug_sendf("PRIVMSG %s :not working yet.\r\n", ircmsg->to);
	return 1;
}

int on_lsmod(char *parameter, MSG *ircmsg)
{
	TRIGGER *t;
	PLUGIN *p;
	DIR *d;
	struct dirent *de;

	char buf[1024];
	int first = 1;
	DListElmt *el, *elt;
	
	d = opendir(mlink->set_get_string("MODULE_PATH"));

	if (d == NULL)
	{
		mlink->log(LOG_WARNING, "Could not access modules directory!");
		return;
	}

	sprintf(buf, "PRIVMSG %s :modules (\002loaded\002): ", ircmsg->to);

	while (de = readdir(d))
	{
		char *pn,*pne,modpath[1024],loaded=0;

		if (!wildcmp("*.so", de->d_name) && !wildcmp("*.dll", de->d_name)) continue;

		pn = de->d_name;

		sprintf(modpath, "%s%s", mlink->set_get_string("MODULE_PATH"), de->d_name);

		if (pne = strrchr(pn, '.')) *pne = 0;

		FOR_EACH(&e_global->plugins, el)
		{
			p = el->data;

			if (strcmp(modpath, p->filename) == 0)
			{
				loaded = 1;
				pn = p->name;
				break;
			}
		}

		if (!first) strcat(buf, ", ");
		if (loaded) strcat(buf, "\002");
		strcat(buf, pn);
		if (loaded) strcat(buf, "\002");

		first = 0;
	}

	/* TODO: this function does not show any modul which is loaded
	   but no longer exist as a file */

	strcat(buf, "\r\n");
	mlink->plug_send(buf);
}

int ep_main()
{	
	mlink->plug_trigger_reg("!lsmod", TRIG_ADMIN, on_lsmod);
	mlink->plug_trigger_reg("!insmod", TRIG_ADMIN, on_insmod);
	mlink->plug_trigger_reg("!rmmod", TRIG_ADMIN, on_rmmod);
	
	return 1;
}

