#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>

#include "eiwic.h"
#include "plugins.h"

EP_SETNAME("wikipedia");

typedef struct wiki_request {
	char channel[128];
	char request[9];
} REQ;

static char last_request[128];
static int last_part;

int wiki_post(char *retrieved, void *data)
{
	REQ *req = data;
	char *p,*q;

	p = strtok(retrieved, "\n");
	while (p)
	{
		mlink->plug_sendf("PRIVMSG %s :%s\r\n", req->channel, p);
		p = strtok(NULL, "\n");
	}
	
	free(req);

	return 1;
}

int wiki_more(char *p, MSG *msg)
{
	REQ *r;
	char http[170];
		
	r = malloc(sizeof(REQ));
	strncpy(r->request, last_request, 127);
	strcpy(r->channel, msg->to);

	mlink->log(LOG_DEBUG, "--");
	sprintf(http,"http://nur.shyce.de/wiki.php?part=%d&word=%s", ++last_part, last_request);

	mlink->conn_http_get(http, wiki_post, r);
}

int wiki(char *parameter, MSG *msg)
{
	REQ *r;
		
	if (parameter == NULL)
		return -1;

	strncpy(last_request, parameter, 127);
	last_part = -1;
	
	wiki_more(NULL, msg);
	
	return 0;
}

/* plugin main function, register trigger */
int ep_main()
{
	mlink->plug_trigger_reg("!wiki", TRIG_PUBLIC, wiki);
	mlink->plug_trigger_reg("!more", TRIG_PUBLIC, wiki_more);
	
	return 1;
}
